#define bell_1 14 //Analog 0
#define bell_2 5  //Digital 5
#define bell_3 15 //Analog 1
#define bell_4 4  //Digital 4
#define bell_5 16 //Analog 2
#define bell_6 3  //Digital 3
#define bell_7 17 //Analog 3
#define bell_8 2  //Digital 2

#define pot_1 5 //Analog pot 5

#define led_Green 6 
#define led_Red 7

int solenoid_duration = 40;  //Length of a note.
int note_tempo = 1000; //Length of a single note/pause cycle. (in ms)
int max_tempo = 300;
int min_tempo = 50;

void setup(){
  pinMode(bell_1,OUTPUT);
  pinMode(bell_2,OUTPUT);
  pinMode(bell_3,OUTPUT);
  pinMode(bell_4,OUTPUT);
  pinMode(bell_5,OUTPUT);
  pinMode(bell_6,OUTPUT);
  pinMode(bell_7,OUTPUT);
  pinMode(bell_8,OUTPUT);
  
  pinMode(led_Green,OUTPUT);
  pinMode(led_Red,OUTPUT);  
  
  digitalWrite(led_Green,HIGH);
  digitalWrite(led_Red,HIGH);

  Serial.begin(9600);
}

void loop(){

  //play_sequence("cdefgABC"); //Scales.
  while(1){
    serial_server();
  }
    
  while(1){ //Loop forever and don't repeat.
    digitalWrite(led_Green,LOW);
  }  
}

void serial_server(){
  //Get data from the serial port
  byte serial_in;
  if (Serial.available()>0){
    serial_in  = Serial.read();
  
    Serial.write(serial_in); //Visual feedback to the PC.
  
    char temp_char = char(serial_in);
    play_sequence( &temp_char ); //Note passing the string as a pointer.(&).
  }
}
void play_sequence(char *notes_string){
    int len = strlen(notes_string);
    for (int n = 0; n < len; n++){
      //Calculate the tempo stuff
      note_tempo = map(analogRead(pot_1),0,1023,min_tempo,max_tempo);
      //Play the note:
      switch (notes_string[n]) {
        case 'c': play(1); break;
        case 'd': play(2); break;
        case 'e': play(3); break;
        case 'f': play(4); break;
        case 'g': play(5); break;
        case 'A': play(6); break;
        case 'B': play(7); break;
        case 'C': play(8); break;
        case '8': delay(note_tempo/4); 
        case '6': delay(note_tempo/4);
        case '4': delay(note_tempo/4);
        case '2': delay(note_tempo/4); break;
        default: ; break;
      }
    Serial.print("tempo is: ");
    Serial.println(note_tempo);    
    }
}

void play(int note_num){
  digitalWrite(led_Red,HIGH);
  switch (note_num)  {
    case 1: digitalWrite(bell_1,HIGH); delay(solenoid_duration); digitalWrite(bell_1,LOW); break;
    case 2: digitalWrite(bell_2,HIGH); delay(solenoid_duration); digitalWrite(bell_2,LOW); break;
    case 3: digitalWrite(bell_3,HIGH); delay(solenoid_duration); digitalWrite(bell_3,LOW); break;
    case 4: digitalWrite(bell_4,HIGH); delay(solenoid_duration); digitalWrite(bell_4,LOW); break;
    case 5: digitalWrite(bell_5,HIGH); delay(solenoid_duration); digitalWrite(bell_5,LOW); break;
    case 6: digitalWrite(bell_6,HIGH); delay(solenoid_duration); digitalWrite(bell_6,LOW); break;
    case 7: digitalWrite(bell_7,HIGH); delay(solenoid_duration); digitalWrite(bell_7,LOW); break;
    case 8: digitalWrite(bell_8,HIGH); delay(solenoid_duration); digitalWrite(bell_8,LOW); break;    
  }
  digitalWrite(led_Red,LOW);
  delay(note_tempo - solenoid_duration);
  Serial.print(note_num);
  Serial.print(", ");  
}
